#include "main.h"
#include "raster.h"
#include "geometry.h"
#include "bitmap.h"
#include <stdio.h>
#include <memory.h>
#include <malloc.h>

//---------------------------------------------------------------------------
void Draw_Scene_ScanSBuffer()
{
        // 
        
		struct span_struct
        {
			float x1;
			float w1;
			float x2;
			float w2;
			int   c;
			int  flag;
		
			//   
			span_struct(){
				x1=w1=x2=w1=0.0;
				c=flag=0;
			};

			// 
			span_struct(float in_x1, float in_w1, float in_x2, float in_w2, int in_c, int in_flag){
				x1=in_x1;
				w1=in_w1;
				x2=in_x2;
				w2=in_w2;
				c=in_c;
				flag=in_flag;
			};

        };
		
		struct tochka_struct
        {
         float x;
         float w;
         int   cv;
         int   pr;
	
		 //   
		 tochka_struct(){
			x=w=0.0;
			cv=pr=0;
		 };

		 // 
		 tochka_struct(float in_x, float in_w, int in_cv, int in_pr){
			x=in_x;
			w=in_w;
			cv=in_cv;
			pr=in_pr;
		 };

        };
		
        int size=3000;
        tochka_struct A;
        tochka_struct B;
        tochka_struct C;
        tochka_struct D;
        tochka_struct P;
        int j,l;
        int kl1=0;
        int kl2=0;
        int kl3=0;
        int p,p2;
        int r;
        float a1,a2,b1,b2,c1,c2,wb1,wb2,wc1,wc2,xo,wo;
        // 

        //         
	Init_Raster_Frame();
	//      ( )
	Plane_struct plane(0,0,-1,-MINIMUM_Z);
	//     
	Line_struct left(-1,0,0),right(1,0,RWidth);
	Line_struct top(0,-1,0),bottom(0,1,RHeight);
	//      
	for(long i=0;i<Number_Faces;i++)
	{
		const Face_struct &face=Faces[i];
		//    
		Circle_List_Template<Vertex3D_struct> Poly3D;
		Poly3D.append(new Vertex3D_struct(Vertices3D[face.vertex[0]]));
		Poly3D.append(new Vertex3D_struct(Vertices3D[face.vertex[1]]));
		Poly3D.append(new Vertex3D_struct(Vertices3D[face.vertex[2]]));
		//    
		if (TruncPolygon3D(Poly3D,plane))
		{
			//    
			Circle_List_Template<Vertex2D_struct> Poly2D;
			ProjectPolygon(Poly3D,Poly2D);

			//    
			if (	TruncPolygon2D(Poly2D,left)	&&	TruncPolygon2D(Poly2D,right)
				&&	TruncPolygon2D(Poly2D,top)	&&	TruncPolygon2D(Poly2D,bottom)	)
			{
				//     
				long ys,ye;
				Prepare_Raster_Polygon(Poly2D,i,ys,ye);
			}
			//     
			Poly2D.clear();
		}
		//     
		Poly3D.clear();
	}

	//  ,   
	Circle_List_Template<Edge_List_struct> Edges;

        // 
        span_struct *BCur=new span_struct[size];
        span_struct *BNext=new span_struct[size];
        span_struct *BNew=new span_struct[size];
        // 

	for(long y=0;y<RHeight;y++)
	{
		//     
		for(Circle_List_Iterator_Template<Edge_List_struct> i(Edges);!i.end();)
		{
			Edge_List_struct *edge=i.get();
			//,   
			if (y>=edge->end)
			{
				delete i.remove();
			}
			else
			{
				//    
				edge->x+=edge->dx;
				edge->w+=edge->dw;
				i.step();
			}
		}

		//   
		while(LineEdges[y])
		{
			Edges.append(LineEdges[y]);
			LineEdges[y]=LineEdges[y]->next;
		}

		//    
		if (!Edges.start()) continue;

		//   ,    
		for(Circle_List_Iterator_Template<Edge_List_struct> e1(Edges);!e1.end();e1.step())
		{
			bool found=false;
			Circle_List_Iterator_Template<Edge_List_struct> e2(e1);
			for(e2.step();!e2.end();e2.step())
				if (e2.get()->ID==e1.get()->ID)	//     
				{
					//   e2   e1
					Edges.insert(Edges.remove(e2.get_node()),e1.get_node());
					found=true;
					break;
				}
			assert(found,"    ");
			e1.step();
		}

		//       

                // 
                kl1=RHeight; // 
                p=0;
                j=1;
                // 

		for(Circle_List_Iterator_Template<Edge_List_struct> s(Edges);!s.end();)
		{
			Edge_List_struct *Edge1=s.get();	s.step();
			Edge_List_struct *Edge2=s.get();	s.step();
			//   
			if (Edge1->ID!=Edge2->ID)	break;

			// Edge1      Edge2
			if (Edge1->x>Edge2->x)	swap(Edge1,Edge2);
			//    
			long xs=(long)floor(Edge1->x+0.5);
			long xe=(long)floor(Edge2->x+0.5);
			//      
			if (xs<0)	xs=0;
			if (xe>RWidth)	xe=RWidth;
			//   
			if (xs>=xe)	continue;

                        // 
                        int cvet=Faces[Edge1->ID].color_id;
                        kl3=1; //  
                        BNew[kl3].x1=Edge1->x;
                        BNew[kl3].w1=Edge1->w;
                        BNew[kl3].x2=Edge2->x;
                        BNew[kl3].w2=Edge2->w;
                        BNew[kl3].c=cvet;
                        BNew[kl3].flag=0;
                        kl2=0;
                        p2=0;
                        j=j+p;
                        for  (j; j<=kl1; j++)
                        {
                           r=0;  //  
                           l=1;
                           l=l+p2;
                           for (l; l<=kl3-r; l++)
                           {
                            BCur[j].flag=0;
                            p++;
                            BNew[l].flag=0;
                            p2++;
							A=tochka_struct(BCur[j].x1, BCur[j].w1, BCur[j].c, 1);
							B=tochka_struct(BCur[j].x2, BCur[j].w2, BCur[j].c, 1);
							C=tochka_struct(BNew[l].x1, BNew[l].w1, BNew[l].c, 2);
							D=tochka_struct(BNew[l].x2, BNew[l].w2, BNew[l].c, 2);

                            if (A.x<B.x) ;else {P=A; A=B; B=P;}
                            if (A.x<C.x) ;else {P=A; A=C; C=P;}
                            if (A.x<D.x) ;else {P=A; A=D; D=P;}
                            if (B.x<C.x) ;else {P=B; B=C; C=P;}
                            if (B.x<D.x) ;else {P=B; B=D; D=P;}
                            if (C.x<D.x) ;else {P=C; C=D; D=P;}

                            a1=BCur[j].w2-BCur[j].w1;
                            b1=BCur[j].x1-BCur[j].x2;
                            c1=BCur[j].x2*BCur[j].w1-BCur[j].x1*BCur[j].w2;
                            a2=BNew[l].w2-BNew[l].w1;
                            b2=BNew[l].x1-BNew[l].x2;
                            c2=BNew[l].x2*BNew[l].w1-BNew[l].x1*BNew[l].w2;
                            xo=(b1*c2-b2*c1)/(a1*b2-a2*b1);
                            wo=(a2*c1-a1*c2)/(a1*b2-a2*b1);

                            if (A.pr==B.pr){
                                            if (A.pr==1){
                                                         kl2++;
														 BNext[kl2]=span_struct(A.x, A.w, B.x, B.w, A.cv, 1);													 
                                                         kl3++;
														 BNew[kl3]=span_struct(C.x, C.w, D.x, D.w, C.cv, 1);
                                                         r++;
                                                         continue;
                                                       }
                                                         else{
                                                              kl2++;
															  BNext[kl2]=span_struct(C.x, C.w, D.x, D.w, C.cv, 1);
                                                              kl3++;
															  BNew[kl3]=span_struct(A.x, A.w, B.x, B.w, A.cv, 1);
                                                              r++;
                                                              continue;
                                                             }
                                           }

                             if (B.pr==1){
                                         wb2=(-c2-a2*B.x)/b2;
                                         wb1=B.w;
                                        }
                            else {
                                  wb1=(-c1-a1*B.x)/b1;
                                  wb2=B.w;
                                 }
                            if (C.pr==1){
                                         wc2=(-c2-a2*C.x)/b2;
                                         wc1=C.w;
                                        }
                            else {
                                  wc1=(-c1-a1*C.x)/b1;
                                  wc2=C.w;
                                 }

                            if (A.x<B.x){
                                         if (A.pr==1)
										 {
                                             kl2++;
											 BNext[kl2]=span_struct(A.x, A.w, B.x, wb1, A.cv, 1);
                                         }
                                         else
										 {
                                              kl3++;
											  BNew[kl3]=span_struct(A.x, A.w, B.x, wb2, A.cv, 1);
                                              r++;
                                         }
                                        }
                            if (C.x<D.x){
                                         if (D.pr==1)
										 {
                                              kl2++;
											  BNext[kl2]=span_struct(C.x, wc1, D.x, D.w, D.cv, 1);
                                         }
                                         else
										 {
                                              kl3++;
											  BNew[kl3]=span_struct(C.x, wc2, D.x, D.w, D.cv, 1);
                                              r++;
                                         }
                                        }
                            if (wb2>=wb1 && wc2>=wc1){
                                                      kl3++;
													  BNew[kl3]=span_struct(B.x, wb2, C.x, wc2, (B.pr==2)?B.cv:(C.pr==2)?C.cv:BNew[kl3].c, 1);
                                                      r++;
                                                     }
                            if (wb1>=wb2 && wc1>=wc2){
                                                     kl2++;
													 BNext[kl2]=span_struct(B.x, wb1, C.x, wc1, (B.pr==1)?B.cv:(C.pr==1)?C.cv:BNew[kl2].c, 1);
                                                    }
                           if (wb2>wb1 && wc2<wc1){
                                                   kl3++;
												   BNew[kl3]=span_struct(B.x, wb2, xo, wo, (B.pr==2)?B.cv:(C.pr==2)?C.cv:BNew[kl3].c, 1);
                                                   r++;
                                                   kl2++;
												   BNext[kl2]=span_struct(xo, wo, C.x, wc1, (B.pr==1)?B.cv:(C.pr==1)?C.cv:BNext[kl2].c, 1);
                                                  }
                           if (wb1>wb2 && wc1<wc2){
                                                   kl2++;
												   BNext[kl2]=span_struct(B.x, wb1, xo, wo, (B.pr==1)?B.cv:(C.pr==1)?C.cv:BNext[kl2].c, 1);
                                                   kl3++;
												   BNew[kl3]=span_struct(xo, wo, C.x, wc2, (B.pr==2)?B.cv:(C.pr==2)?C.cv:BNew[kl3].c, 1);
                                                   r++;
                                                  }
                        }
                        }
                        for (int m=1; m<=kl2; m++)
                        {
                         kl1++;
						 BCur[kl1]=BNext[m];
                        }
                        for (int n=1; n<=kl3; n++)
                        {
                         kl1++;
						BCur[kl1]=BNew[n];
                        }
                        for (int s=1; s<=kl1; s++)
                        {
                         if (BCur[s].flag==0){
                                              for (int t=s; t<=kl1-1; t++)
                                              {
                                               BCur[t]=BCur[t+1];
                                              }
                                              kl1--;
                                             }
                        }   
		}
        //  
        for (int o=1; o<=kl1; o++) if (BCur[o].flag==1){
                                                        long xs=(long)floor(BCur[o].x1+0.5);
                                                        long xe=(long)floor(BCur[o].x2+0.5);
                                                        for(long x=xs;x<xe;x++) Put_Pixel(x,y,BCur[o].c);
                                                       };
	}
        delete BCur;
        delete BNext;
        delete BNew;
                        // 
        //  
	Edges.clear();
}

//---------------------------------------------------------------------------
// -  
#define NUMBER_SCENES		5
// -   
#define NUMBER_RESOLUTIONS	5

//---------------------------------------------------------------------------
//  
void User_Main()
{
	//   
//	User_Test();	return;

	//      
	double time[NUMBER_SCENES][NUMBER_RESOLUTIONS];
	// -    
	long number_pixels[NUMBER_RESOLUTIONS];
	// -    
	long number_polygones[NUMBER_SCENES];

	for(int i=0;i<NUMBER_SCENES;i++)
	{
		//  scene_X, X -    
		if (!LoadScene("Data\\scene_8",i+1))	return;
		number_polygones[i]=Number_Faces;

		for(int j=0;j<NUMBER_RESOLUTIONS;j++)
		{
			//   
		Set_Resolution_Factor(NUMBER_RESOLUTIONS+1-j);
//	Set_Resolution_Factor(0);
			number_pixels[j]=RWidth*RHeight;
  			double takts=Get_Takts();
  			//  
			switch(3)
			{
				case 3:	Draw_Scene_ScanSBuffer();		break;
			}
			//    
			time[i][j]=Get_Takts()-takts;
			//    
			Update_View(true);
		}
		//       
		if (i==(NUMBER_SCENES-1))	SaveBMP("result.bmp",ImageArray,Colors,RWidth,RHeight);
		//   
		Clear_Scene();
	}
	//   
	FILE *file = fopen("results.txt","wt");
	assert(file,"   ");
	if (file)
	{
		fprintf(file,"Pixels\\Polygones ");
		for(int i=0;i<NUMBER_SCENES;i++)
			fprintf(file,"    %5d",number_polygones[i]);
		fprintf(file,"\n");
		for(int j=0;j<NUMBER_RESOLUTIONS;j++)
		{
			fprintf(file," %5d           ",number_pixels[j]);
			for(int i=0;i<NUMBER_SCENES;i++)
			{
				fprintf(file," %8d",long(time[i][j]/1000));
			}
			fprintf(file,"\n");
		}
	}
	fclose(file);
}
